<template lang="pug">
  user-layout
    user-actions(
      slot="actions"
      v-on:search="filterUsers"
    )
    users-table(:users="usersFiltered" slot="table")
    user-profile(slot="profile")

</template>

<script>
	import auth from '../../utils/auth'
	import user from '../../utils/user'
	import Modal from '../Utils/Modal'
  import HeaderTop from '../Utils/HeaderTop'
  import UsersTable from './UsersTable'
  import UserLayout from './UserLayout'
  import UserActions from './UserActions'
  import UserProfile from './UserProfile'
	// import ModalConfirm from './ModalConfirm'

	function userSchema() {
		return {
			userId: '',
			username: '',
			password: '',
			name: {
				first: '',
				last: ''
			},
			email: ''
		}
	}

	export default {
		name: 'Users',
		components: {
			Modal,
      HeaderTop,
      UsersTable,
      UserLayout,
      UserActions,
      UserProfile
			// ModalConfirm
		},
		data() {
			return {
					// User Schema
					user: userSchema(),
					// list of users
					users: [],
          usersFiltered: [],
					// component state
					modalShow: false,
          importUsersModalShow: false,
          importUsersJSON: '',
          deleteConfirm: false,
          deleteId: '',
          userFilter: ''

        }
      },
      computed: {
        // usersFiltered() {
        //   return this.users.filter((u) => { return u.username.toLowerCase().search(this.userFilter) != -1 })
        // },

      },

      methods: {

        filterUsers(search, param) {
          if (param == 'all') {
            this.usersFiltered = this.users.filter((u) => {
              return u.name.first
              .concat(u.name.last)
              .concat(u.email)
              .concat(u.username)
              .toLowerCase().search(search) != -1
            })
          } else if (param == 'name') {
            this.usersFiltered = this.users.filter((u) => {
              return u.name.first.concat(u.name.last).toLowerCase().search(search) != -1
            })
          } else {
            this.usersFiltered = this.users.filter((u) => {
              return u[param].toLowerCase().search(search) != -1
            })
          }

        },


        addUser() {
         var newUser = this.user

         user.newUser(this, newUser)
         .then((user) => this.users.push(user))
         // .then((user) => this.usersFiltered.push(user))

         this.modalShow = false
         this.user = userSchema()
       },

       deleteUser(id) {
         // alert('delete ' + id)
         user.deleteUser(this, id)
         .then((res) => {
          if (res.result == "OK") {
           this.users = this.users.filter((v) => { return v.userId != id })
           this.deleteConfirm = false
         }
       })
       },

       importUsers() {
        let that = this
        let newUsers = JSON.parse(this.importUsersJSON)
        for (let i = 0; i <= newUsers.length - 1; i++) {
          user.newUser(that, newUsers[i])
          .then((user) => that.users.push(user))
        }

        this.importUsersModalShow = false
        // user.newUser(this, newUsers[0])
        //  .then((user) => this.users.push(user))
        // console.log(newUsers)

      },
    },
    mounted() {
      let self = this
      user.getAllUsers(this)
			// .then((res) => console.log(res))
			.then((users) => {
        self.users = users
        self.usersFiltered = users
      })
			.catch((err) => console.error(err))

		}
	}
</script>

<style lang="scss">
	.users {
		img {
			width: 30px;
		}
		td {
			vertical-align: middle;
		}
		.deleteConfirm {
			text-align: right;
			cursor: pointer;
		}
	}

  .checkmark {
   display: inline-block;
   background-color: rgba(10, 10, 10, 0.1);
   height: 24px;
   width: 24px;
   border-radius: 50%;

 }
 .checkmark:after {
  content: '';
  display: block;
  position: absolute;
  margin-top: 5px;
  margin-left: 9px;


  width: 6px;
  height: 10px;

  border: solid #fff;
  border-width: 0 2px 2px 0;
  transform: rotate(45deg);

}

.checkmark-small {
  display: inline-block;
  background-color: rgba(10, 10, 10, 0.1);
  height: 16px;
  width: 16px;
  border-radius: 50%;
  margin-left: 7px;
}

.checkmark-small:hover {
  background-color: rgba(10, 10, 10, 0.2);
}

.checkmark-small:after {
  content: '';
  display: block;
  position: absolute;
  margin-top: 3px;
  margin-left: 6px;


  width: 5px;
  height: 8px;

  border: solid #fff;
  border-width: 0 2px 2px 0;
  transform: rotate(45deg);

}

</style>
